#if defined(ARMADILLOJ_CTYPE)
#include <target/flash.h>
#include "flash.h"
#include "memregions.h"

unsigned int get_flash_size(void){
  switch(flash_id){
  case FLASH_DID_ST_M29W160EB:
    return FLASH_SIZE_2M;
  case FLASH_DID_ST_M29DW323DB:
    return FLASH_SIZE_4M;
  default:
    return FLASH_SIZE_2M;
  }
  return 0;
}

unsigned int get_user_size(void){
  switch(flash_id){
  case FLASH_DID_ST_M29W160EB:
    return USER_SIZE_2M;
  case FLASH_DID_ST_M29DW323DB:
    return USER_SIZE_4M;
  default:
    return USER_SIZE_2M;
  }
  return 0;
}

char *get_user_blocking(void){
  switch(flash_id){
  case FLASH_DID_ST_M29W160EB:
    return USER_BLOCKS_2M;
  case FLASH_DID_ST_M29DW323DB:
    return USER_BLOCKS_4M;
  default:
    return USER_BLOCKS_2M;
  }
  return 0;
}

#endif //ARMADILLOJ_CTYPE









